/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
	"reflect"
	"time"
)


// ReportsAPIService ReportsAPI service
type ReportsAPIService service

type ApiCreateExportRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	exportRequest *ExportRequest
}

func (r ApiCreateExportRequest) ExportRequest(exportRequest ExportRequest) ApiCreateExportRequest {
	r.exportRequest = &exportRequest
	return r
}

func (r ApiCreateExportRequest) Execute() (*ExportJob, *http.Response, error) {
	return r.ApiService.CreateExportExecute(r)
}

/*
CreateExport Create export

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiCreateExportRequest
*/
func (a *ReportsAPIService) CreateExport(ctx context.Context, orgId string) ApiCreateExportRequest {
	return ApiCreateExportRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return ExportJob
func (a *ReportsAPIService) CreateExportExecute(r ApiCreateExportRequest) (*ExportJob, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ExportJob
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.CreateExport")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/exports"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.exportRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCreateHighlightConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
	highlightMutable *HighlightMutable
}

func (r ApiCreateHighlightConfigurationRequest) HighlightMutable(highlightMutable HighlightMutable) ApiCreateHighlightConfigurationRequest {
	r.highlightMutable = &highlightMutable
	return r
}

func (r ApiCreateHighlightConfigurationRequest) Execute() (*Highlight, *http.Response, error) {
	return r.ApiService.CreateHighlightConfigurationExecute(r)
}

/*
CreateHighlightConfiguration Create highlight configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiCreateHighlightConfigurationRequest
*/
func (a *ReportsAPIService) CreateHighlightConfiguration(ctx context.Context, orgId string, confId string) ApiCreateHighlightConfigurationRequest {
	return ApiCreateHighlightConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return Highlight
func (a *ReportsAPIService) CreateHighlightConfigurationExecute(r ApiCreateHighlightConfigurationRequest) (*Highlight, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *Highlight
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.CreateHighlightConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.highlightMutable
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCreateReportConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	reportConfigurationMutable *ReportConfigurationMutable
}

func (r ApiCreateReportConfigurationRequest) ReportConfigurationMutable(reportConfigurationMutable ReportConfigurationMutable) ApiCreateReportConfigurationRequest {
	r.reportConfigurationMutable = &reportConfigurationMutable
	return r
}

func (r ApiCreateReportConfigurationRequest) Execute() (*ReportConfiguration, *http.Response, error) {
	return r.ApiService.CreateReportConfigurationExecute(r)
}

/*
CreateReportConfiguration Create report configuration

Create new report configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiCreateReportConfigurationRequest
*/
func (a *ReportsAPIService) CreateReportConfiguration(ctx context.Context, orgId string) ApiCreateReportConfigurationRequest {
	return ApiCreateReportConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return ReportConfiguration
func (a *ReportsAPIService) CreateReportConfigurationExecute(r ApiCreateReportConfigurationRequest) (*ReportConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ReportConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.CreateReportConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.reportConfigurationMutable
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 422 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiDeleteHighlightConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
}

func (r ApiDeleteHighlightConfigurationRequest) Execute() (*GenericResponse, *http.Response, error) {
	return r.ApiService.DeleteHighlightConfigurationExecute(r)
}

/*
DeleteHighlightConfiguration Delete highlight configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiDeleteHighlightConfigurationRequest
*/
func (a *ReportsAPIService) DeleteHighlightConfiguration(ctx context.Context, orgId string, confId string) ApiDeleteHighlightConfigurationRequest {
	return ApiDeleteHighlightConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return GenericResponse
func (a *ReportsAPIService) DeleteHighlightConfigurationExecute(r ApiDeleteHighlightConfigurationRequest) (*GenericResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GenericResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.DeleteHighlightConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiDeleteReportConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
}

func (r ApiDeleteReportConfigurationRequest) Execute() (*GenericResponse, *http.Response, error) {
	return r.ApiService.DeleteReportConfigurationExecute(r)
}

/*
DeleteReportConfiguration Delete report configuration

Delete report configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiDeleteReportConfigurationRequest
*/
func (a *ReportsAPIService) DeleteReportConfiguration(ctx context.Context, orgId string, confId string) ApiDeleteReportConfigurationRequest {
	return ApiDeleteReportConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return GenericResponse
func (a *ReportsAPIService) DeleteReportConfigurationExecute(r ApiDeleteReportConfigurationRequest) (*GenericResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GenericResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.DeleteReportConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiDeleteSubscriberRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
	subscriberId string
}

func (r ApiDeleteSubscriberRequest) Execute() (*GenericResponse, *http.Response, error) {
	return r.ApiService.DeleteSubscriberExecute(r)
}

/*
DeleteSubscriber Delete subscriber

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @param subscriberId
 @return ApiDeleteSubscriberRequest
*/
func (a *ReportsAPIService) DeleteSubscriber(ctx context.Context, orgId string, confId string, subscriberId string) ApiDeleteSubscriberRequest {
	return ApiDeleteSubscriberRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
		subscriberId: subscriberId,
	}
}

// Execute executes the request
//  @return GenericResponse
func (a *ReportsAPIService) DeleteSubscriberExecute(r ApiDeleteSubscriberRequest) (*GenericResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GenericResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.DeleteSubscriber")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight/subscribers/{subscriber_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"subscriber_id"+"}", url.PathEscape(parameterValueToString(r.subscriberId, "subscriberId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetCohortReportRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	rolloutId *string
	resultType *string
	channelIds *[]string
	ixIds *[]string
	locationIds *[]string
	epIds *[]string
	messengers *[]string
	triggerTypes *[]string
	entryTypes *[]string
	tags *[]string
	languages *[]string
	segments *[]string
	labels *[]string
	deviceBrands *[]string
	browserNames *[]string
	countryCodes *[]string
	groupBy *[]string
	from *time.Time
	to *time.Time
	format *string
	sort *[]string
	limit *int32
	offset *int32
	contextValues *[]string
	contextFields *[]string
	groupByContextField *string
}

// Rollout id
func (r ApiGetCohortReportRequest) RolloutId(rolloutId string) ApiGetCohortReportRequest {
	r.rolloutId = &rolloutId
	return r
}

// Report results type
func (r ApiGetCohortReportRequest) ResultType(resultType string) ApiGetCohortReportRequest {
	r.resultType = &resultType
	return r
}

// Channel ids filter
func (r ApiGetCohortReportRequest) ChannelIds(channelIds []string) ApiGetCohortReportRequest {
	r.channelIds = &channelIds
	return r
}

// Interaction ids filter
func (r ApiGetCohortReportRequest) IxIds(ixIds []string) ApiGetCohortReportRequest {
	r.ixIds = &ixIds
	return r
}

// Location ids filter
func (r ApiGetCohortReportRequest) LocationIds(locationIds []string) ApiGetCohortReportRequest {
	r.locationIds = &locationIds
	return r
}

// Entry Points ids filter
func (r ApiGetCohortReportRequest) EpIds(epIds []string) ApiGetCohortReportRequest {
	r.epIds = &epIds
	return r
}

// Messengers filter
func (r ApiGetCohortReportRequest) Messengers(messengers []string) ApiGetCohortReportRequest {
	r.messengers = &messengers
	return r
}

// Trigger types filter
func (r ApiGetCohortReportRequest) TriggerTypes(triggerTypes []string) ApiGetCohortReportRequest {
	r.triggerTypes = &triggerTypes
	return r
}

// Entry types filter
func (r ApiGetCohortReportRequest) EntryTypes(entryTypes []string) ApiGetCohortReportRequest {
	r.entryTypes = &entryTypes
	return r
}

// Tags filter
func (r ApiGetCohortReportRequest) Tags(tags []string) ApiGetCohortReportRequest {
	r.tags = &tags
	return r
}

// Languages filter
func (r ApiGetCohortReportRequest) Languages(languages []string) ApiGetCohortReportRequest {
	r.languages = &languages
	return r
}

// Segments filter
func (r ApiGetCohortReportRequest) Segments(segments []string) ApiGetCohortReportRequest {
	r.segments = &segments
	return r
}

// Labels filter
func (r ApiGetCohortReportRequest) Labels(labels []string) ApiGetCohortReportRequest {
	r.labels = &labels
	return r
}

// Device brands filter
func (r ApiGetCohortReportRequest) DeviceBrands(deviceBrands []string) ApiGetCohortReportRequest {
	r.deviceBrands = &deviceBrands
	return r
}

// Browser names filter
func (r ApiGetCohortReportRequest) BrowserNames(browserNames []string) ApiGetCohortReportRequest {
	r.browserNames = &browserNames
	return r
}

// Country codes filter
func (r ApiGetCohortReportRequest) CountryCodes(countryCodes []string) ApiGetCohortReportRequest {
	r.countryCodes = &countryCodes
	return r
}

// Group by
func (r ApiGetCohortReportRequest) GroupBy(groupBy []string) ApiGetCohortReportRequest {
	r.groupBy = &groupBy
	return r
}

// Time from
func (r ApiGetCohortReportRequest) From(from time.Time) ApiGetCohortReportRequest {
	r.from = &from
	return r
}

// Time to
func (r ApiGetCohortReportRequest) To(to time.Time) ApiGetCohortReportRequest {
	r.to = &to
	return r
}

// Set to get data as xlsx or csv, instead of json
func (r ApiGetCohortReportRequest) Format(format string) ApiGetCohortReportRequest {
	r.format = &format
	return r
}

// List of fields to sort by, &#x60;-&#x60; prefix means descending order
func (r ApiGetCohortReportRequest) Sort(sort []string) ApiGetCohortReportRequest {
	r.sort = &sort
	return r
}

func (r ApiGetCohortReportRequest) Limit(limit int32) ApiGetCohortReportRequest {
	r.limit = &limit
	return r
}

func (r ApiGetCohortReportRequest) Offset(offset int32) ApiGetCohortReportRequest {
	r.offset = &offset
	return r
}

// Context values filter
func (r ApiGetCohortReportRequest) ContextValues(contextValues []string) ApiGetCohortReportRequest {
	r.contextValues = &contextValues
	return r
}

// Context fields filter
func (r ApiGetCohortReportRequest) ContextFields(contextFields []string) ApiGetCohortReportRequest {
	r.contextFields = &contextFields
	return r
}

// Context field name for group by
func (r ApiGetCohortReportRequest) GroupByContextField(groupByContextField string) ApiGetCohortReportRequest {
	r.groupByContextField = &groupByContextField
	return r
}

func (r ApiGetCohortReportRequest) Execute() (*ReportCohort, *http.Response, error) {
	return r.ApiService.GetCohortReportExecute(r)
}

/*
GetCohortReport Get cohort report

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiGetCohortReportRequest
*/
func (a *ReportsAPIService) GetCohortReport(ctx context.Context, orgId string) ApiGetCohortReportRequest {
	return ApiGetCohortReportRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return ReportCohort
func (a *ReportsAPIService) GetCohortReportExecute(r ApiGetCohortReportRequest) (*ReportCohort, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ReportCohort
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.GetCohortReport")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/cohort"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.rolloutId != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "rollout_id", r.rolloutId, "")
	}
	if r.resultType != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "result_type", r.resultType, "")
	}
	if r.channelIds != nil {
		t := *r.channelIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "channel_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "channel_ids[]", t, "multi")
		}
	}
	if r.ixIds != nil {
		t := *r.ixIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "ix_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "ix_ids[]", t, "multi")
		}
	}
	if r.locationIds != nil {
		t := *r.locationIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "location_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "location_ids[]", t, "multi")
		}
	}
	if r.epIds != nil {
		t := *r.epIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "ep_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "ep_ids[]", t, "multi")
		}
	}
	if r.messengers != nil {
		t := *r.messengers
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "messengers[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "messengers[]", t, "multi")
		}
	}
	if r.triggerTypes != nil {
		t := *r.triggerTypes
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "trigger_types[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "trigger_types[]", t, "multi")
		}
	}
	if r.entryTypes != nil {
		t := *r.entryTypes
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "entry_types[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "entry_types[]", t, "multi")
		}
	}
	if r.tags != nil {
		t := *r.tags
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", t, "multi")
		}
	}
	if r.languages != nil {
		t := *r.languages
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", t, "multi")
		}
	}
	if r.segments != nil {
		t := *r.segments
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "segments[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "segments[]", t, "multi")
		}
	}
	if r.labels != nil {
		t := *r.labels
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "labels[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "labels[]", t, "multi")
		}
	}
	if r.deviceBrands != nil {
		t := *r.deviceBrands
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "device_brands[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "device_brands[]", t, "multi")
		}
	}
	if r.browserNames != nil {
		t := *r.browserNames
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "browser_names[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "browser_names[]", t, "multi")
		}
	}
	if r.countryCodes != nil {
		t := *r.countryCodes
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "country_codes[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "country_codes[]", t, "multi")
		}
	}
	if r.groupBy != nil {
		t := *r.groupBy
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "group_by[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "group_by[]", t, "multi")
		}
	}
	if r.from != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "from", r.from, "")
	}
	if r.to != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "to", r.to, "")
	}
	if r.format != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "format", r.format, "")
	}
	if r.sort != nil {
		t := *r.sort
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "sort[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "sort[]", t, "multi")
		}
	}
	if r.limit != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "limit", r.limit, "")
	}
	if r.offset != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "offset", r.offset, "")
	}
	if r.contextValues != nil {
		t := *r.contextValues
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "context_values[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "context_values[]", t, "multi")
		}
	}
	if r.contextFields != nil {
		t := *r.contextFields
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "context_fields[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "context_fields[]", t, "multi")
		}
	}
	if r.groupByContextField != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "group_by_context_field", r.groupByContextField, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetHighlightConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
}

func (r ApiGetHighlightConfigurationRequest) Execute() (*Highlight, *http.Response, error) {
	return r.ApiService.GetHighlightConfigurationExecute(r)
}

/*
GetHighlightConfiguration Get highlight configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiGetHighlightConfigurationRequest
*/
func (a *ReportsAPIService) GetHighlightConfiguration(ctx context.Context, orgId string, confId string) ApiGetHighlightConfigurationRequest {
	return ApiGetHighlightConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return Highlight
func (a *ReportsAPIService) GetHighlightConfigurationExecute(r ApiGetHighlightConfigurationRequest) (*Highlight, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *Highlight
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.GetHighlightConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetLastUpdateTimeRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
}

func (r ApiGetLastUpdateTimeRequest) Execute() (*LastUpdate, *http.Response, error) {
	return r.ApiService.GetLastUpdateTimeExecute(r)
}

/*
GetLastUpdateTime Get Last Update Time



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiGetLastUpdateTimeRequest
*/
func (a *ReportsAPIService) GetLastUpdateTime(ctx context.Context, orgId string) ApiGetLastUpdateTimeRequest {
	return ApiGetLastUpdateTimeRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return LastUpdate
func (a *ReportsAPIService) GetLastUpdateTimeExecute(r ApiGetLastUpdateTimeRequest) (*LastUpdate, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *LastUpdate
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.GetLastUpdateTime")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/last-update"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 425 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetRawDataReportRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	channelIds *[]string
	ixIds *[]string
	locationIds *[]string
	epIds *[]string
	messengers *[]string
	triggerTypes *[]string
	entryTypes *[]string
	tags *[]string
	languages *[]string
	segments *[]string
	labels *[]string
	deviceBrands *[]string
	browserNames *[]string
	countryCodes *[]string
	from *time.Time
	to *time.Time
	format *string
	contextValues *[]string
	contextFields *[]string
}

// Channel ids filter
func (r ApiGetRawDataReportRequest) ChannelIds(channelIds []string) ApiGetRawDataReportRequest {
	r.channelIds = &channelIds
	return r
}

// Interaction ids filter
func (r ApiGetRawDataReportRequest) IxIds(ixIds []string) ApiGetRawDataReportRequest {
	r.ixIds = &ixIds
	return r
}

// Location ids filter
func (r ApiGetRawDataReportRequest) LocationIds(locationIds []string) ApiGetRawDataReportRequest {
	r.locationIds = &locationIds
	return r
}

// Entry Points ids filter
func (r ApiGetRawDataReportRequest) EpIds(epIds []string) ApiGetRawDataReportRequest {
	r.epIds = &epIds
	return r
}

// Messengers filter
func (r ApiGetRawDataReportRequest) Messengers(messengers []string) ApiGetRawDataReportRequest {
	r.messengers = &messengers
	return r
}

// Trigger types filter
func (r ApiGetRawDataReportRequest) TriggerTypes(triggerTypes []string) ApiGetRawDataReportRequest {
	r.triggerTypes = &triggerTypes
	return r
}

// Entry types filter
func (r ApiGetRawDataReportRequest) EntryTypes(entryTypes []string) ApiGetRawDataReportRequest {
	r.entryTypes = &entryTypes
	return r
}

// Tags filter
func (r ApiGetRawDataReportRequest) Tags(tags []string) ApiGetRawDataReportRequest {
	r.tags = &tags
	return r
}

// Languages filter
func (r ApiGetRawDataReportRequest) Languages(languages []string) ApiGetRawDataReportRequest {
	r.languages = &languages
	return r
}

// Segments filter
func (r ApiGetRawDataReportRequest) Segments(segments []string) ApiGetRawDataReportRequest {
	r.segments = &segments
	return r
}

// Labels filter
func (r ApiGetRawDataReportRequest) Labels(labels []string) ApiGetRawDataReportRequest {
	r.labels = &labels
	return r
}

// Device brands filter
func (r ApiGetRawDataReportRequest) DeviceBrands(deviceBrands []string) ApiGetRawDataReportRequest {
	r.deviceBrands = &deviceBrands
	return r
}

// Browser names filter
func (r ApiGetRawDataReportRequest) BrowserNames(browserNames []string) ApiGetRawDataReportRequest {
	r.browserNames = &browserNames
	return r
}

// Country codes filter
func (r ApiGetRawDataReportRequest) CountryCodes(countryCodes []string) ApiGetRawDataReportRequest {
	r.countryCodes = &countryCodes
	return r
}

// Time from
func (r ApiGetRawDataReportRequest) From(from time.Time) ApiGetRawDataReportRequest {
	r.from = &from
	return r
}

// Time to
func (r ApiGetRawDataReportRequest) To(to time.Time) ApiGetRawDataReportRequest {
	r.to = &to
	return r
}

// Set to get data as xlsx or csv, instead of json
func (r ApiGetRawDataReportRequest) Format(format string) ApiGetRawDataReportRequest {
	r.format = &format
	return r
}

// Context values filter
func (r ApiGetRawDataReportRequest) ContextValues(contextValues []string) ApiGetRawDataReportRequest {
	r.contextValues = &contextValues
	return r
}

// Context fields filter
func (r ApiGetRawDataReportRequest) ContextFields(contextFields []string) ApiGetRawDataReportRequest {
	r.contextFields = &contextFields
	return r
}

func (r ApiGetRawDataReportRequest) Execute() (*ReportRawData, *http.Response, error) {
	return r.ApiService.GetRawDataReportExecute(r)
}

/*
GetRawDataReport Get raw data report

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiGetRawDataReportRequest
*/
func (a *ReportsAPIService) GetRawDataReport(ctx context.Context, orgId string) ApiGetRawDataReportRequest {
	return ApiGetRawDataReportRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return ReportRawData
func (a *ReportsAPIService) GetRawDataReportExecute(r ApiGetRawDataReportRequest) (*ReportRawData, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ReportRawData
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.GetRawDataReport")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/raw"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.channelIds != nil {
		t := *r.channelIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "channel_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "channel_ids[]", t, "multi")
		}
	}
	if r.ixIds != nil {
		t := *r.ixIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "ix_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "ix_ids[]", t, "multi")
		}
	}
	if r.locationIds != nil {
		t := *r.locationIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "location_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "location_ids[]", t, "multi")
		}
	}
	if r.epIds != nil {
		t := *r.epIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "ep_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "ep_ids[]", t, "multi")
		}
	}
	if r.messengers != nil {
		t := *r.messengers
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "messengers[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "messengers[]", t, "multi")
		}
	}
	if r.triggerTypes != nil {
		t := *r.triggerTypes
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "trigger_types[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "trigger_types[]", t, "multi")
		}
	}
	if r.entryTypes != nil {
		t := *r.entryTypes
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "entry_types[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "entry_types[]", t, "multi")
		}
	}
	if r.tags != nil {
		t := *r.tags
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", t, "multi")
		}
	}
	if r.languages != nil {
		t := *r.languages
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", t, "multi")
		}
	}
	if r.segments != nil {
		t := *r.segments
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "segments[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "segments[]", t, "multi")
		}
	}
	if r.labels != nil {
		t := *r.labels
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "labels[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "labels[]", t, "multi")
		}
	}
	if r.deviceBrands != nil {
		t := *r.deviceBrands
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "device_brands[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "device_brands[]", t, "multi")
		}
	}
	if r.browserNames != nil {
		t := *r.browserNames
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "browser_names[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "browser_names[]", t, "multi")
		}
	}
	if r.countryCodes != nil {
		t := *r.countryCodes
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "country_codes[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "country_codes[]", t, "multi")
		}
	}
	if r.from != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "from", r.from, "")
	}
	if r.to != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "to", r.to, "")
	}
	if r.format != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "format", r.format, "")
	}
	if r.contextValues != nil {
		t := *r.contextValues
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "context_values[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "context_values[]", t, "multi")
		}
	}
	if r.contextFields != nil {
		t := *r.contextFields
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "context_fields[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "context_fields[]", t, "multi")
		}
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetSlaceConnectsRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
}

func (r ApiGetSlaceConnectsRequest) Execute() ([]SlaceConnect, *http.Response, error) {
	return r.ApiService.GetSlaceConnectsExecute(r)
}

/*
GetSlaceConnects Get slace connects



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiGetSlaceConnectsRequest
*/
func (a *ReportsAPIService) GetSlaceConnects(ctx context.Context, orgId string) ApiGetSlaceConnectsRequest {
	return ApiGetSlaceConnectsRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return []SlaceConnect
func (a *ReportsAPIService) GetSlaceConnectsExecute(r ApiGetSlaceConnectsRequest) ([]SlaceConnect, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  []SlaceConnect
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.GetSlaceConnects")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/slace-connects"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiListExportsRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
}

func (r ApiListExportsRequest) Execute() (*ExportJobsList, *http.Response, error) {
	return r.ApiService.ListExportsExecute(r)
}

/*
ListExports List exports

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiListExportsRequest
*/
func (a *ReportsAPIService) ListExports(ctx context.Context, orgId string) ApiListExportsRequest {
	return ApiListExportsRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return ExportJobsList
func (a *ReportsAPIService) ListExportsExecute(r ApiListExportsRequest) (*ExportJobsList, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ExportJobsList
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.ListExports")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/exports"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiListHighlightSubscribersRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
}

func (r ApiListHighlightSubscribersRequest) Execute() ([]HighlightSubscriber, *http.Response, error) {
	return r.ApiService.ListHighlightSubscribersExecute(r)
}

/*
ListHighlightSubscribers List highlight subscribers

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiListHighlightSubscribersRequest
*/
func (a *ReportsAPIService) ListHighlightSubscribers(ctx context.Context, orgId string, confId string) ApiListHighlightSubscribersRequest {
	return ApiListHighlightSubscribersRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return []HighlightSubscriber
func (a *ReportsAPIService) ListHighlightSubscribersExecute(r ApiListHighlightSubscribersRequest) ([]HighlightSubscriber, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  []HighlightSubscriber
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.ListHighlightSubscribers")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight/subscribers"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiListInteractionsWithMetricsRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	channelId string
	name *string
	restart *bool
	ids *[]string
	states *[]string
	tags *[]string
	languages *[]string
	messengers *[]string
	offset *string
	limit *string
	sort *string
	triggerTemplate *string
	liveFrom *time.Time
	liveTo *time.Time
}

func (r ApiListInteractionsWithMetricsRequest) Name(name string) ApiListInteractionsWithMetricsRequest {
	r.name = &name
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Restart(restart bool) ApiListInteractionsWithMetricsRequest {
	r.restart = &restart
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Ids(ids []string) ApiListInteractionsWithMetricsRequest {
	r.ids = &ids
	return r
}

func (r ApiListInteractionsWithMetricsRequest) States(states []string) ApiListInteractionsWithMetricsRequest {
	r.states = &states
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Tags(tags []string) ApiListInteractionsWithMetricsRequest {
	r.tags = &tags
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Languages(languages []string) ApiListInteractionsWithMetricsRequest {
	r.languages = &languages
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Messengers(messengers []string) ApiListInteractionsWithMetricsRequest {
	r.messengers = &messengers
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Offset(offset string) ApiListInteractionsWithMetricsRequest {
	r.offset = &offset
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Limit(limit string) ApiListInteractionsWithMetricsRequest {
	r.limit = &limit
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Sort(sort string) ApiListInteractionsWithMetricsRequest {
	r.sort = &sort
	return r
}

func (r ApiListInteractionsWithMetricsRequest) TriggerTemplate(triggerTemplate string) ApiListInteractionsWithMetricsRequest {
	r.triggerTemplate = &triggerTemplate
	return r
}

// Find all with &#x60;live from&#x60; greater than/equal
func (r ApiListInteractionsWithMetricsRequest) LiveFrom(liveFrom time.Time) ApiListInteractionsWithMetricsRequest {
	r.liveFrom = &liveFrom
	return r
}

// Find all with &#x60;live to&#x60; less than/equal
func (r ApiListInteractionsWithMetricsRequest) LiveTo(liveTo time.Time) ApiListInteractionsWithMetricsRequest {
	r.liveTo = &liveTo
	return r
}

func (r ApiListInteractionsWithMetricsRequest) Execute() (*InteractionsWithMetricsList, *http.Response, error) {
	return r.ApiService.ListInteractionsWithMetricsExecute(r)
}

/*
ListInteractionsWithMetrics List interactions with metrics



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @return ApiListInteractionsWithMetricsRequest
*/
func (a *ReportsAPIService) ListInteractionsWithMetrics(ctx context.Context, channelId string) ApiListInteractionsWithMetricsRequest {
	return ApiListInteractionsWithMetricsRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
	}
}

// Execute executes the request
//  @return InteractionsWithMetricsList
func (a *ReportsAPIService) ListInteractionsWithMetricsExecute(r ApiListInteractionsWithMetricsRequest) (*InteractionsWithMetricsList, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *InteractionsWithMetricsList
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.ListInteractionsWithMetrics")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/interactions-with-metrics"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.name != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "name", r.name, "")
	}
	if r.restart != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "restart", r.restart, "")
	}
	if r.ids != nil {
		t := *r.ids
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "ids[]", t, "multi")
		}
	}
	if r.states != nil {
		t := *r.states
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "states[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "states[]", t, "multi")
		}
	}
	if r.tags != nil {
		t := *r.tags
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", t, "multi")
		}
	}
	if r.languages != nil {
		t := *r.languages
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", t, "multi")
		}
	}
	if r.messengers != nil {
		t := *r.messengers
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "messengers[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "messengers[]", t, "multi")
		}
	}
	if r.offset != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "offset", r.offset, "")
	}
	if r.limit != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "limit", r.limit, "")
	}
	if r.sort != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "sort", r.sort, "")
	}
	if r.triggerTemplate != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "trigger_template", r.triggerTemplate, "")
	}
	if r.liveFrom != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "live_from", r.liveFrom, "")
	}
	if r.liveTo != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "live_to", r.liveTo, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiListReportsOrganizationsRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
}

func (r ApiListReportsOrganizationsRequest) Execute() ([]ReportConfiguration, *http.Response, error) {
	return r.ApiService.ListReportsOrganizationsExecute(r)
}

/*
ListReportsOrganizations List reports configurations

List all reports configurations in organization

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @return ApiListReportsOrganizationsRequest
*/
func (a *ReportsAPIService) ListReportsOrganizations(ctx context.Context, orgId string) ApiListReportsOrganizationsRequest {
	return ApiListReportsOrganizationsRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
	}
}

// Execute executes the request
//  @return []ReportConfiguration
func (a *ReportsAPIService) ListReportsOrganizationsExecute(r ApiListReportsOrganizationsRequest) ([]ReportConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  []ReportConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.ListReportsOrganizations")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUpdateHighlightConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
	highlightMutable *HighlightMutable
}

func (r ApiUpdateHighlightConfigurationRequest) HighlightMutable(highlightMutable HighlightMutable) ApiUpdateHighlightConfigurationRequest {
	r.highlightMutable = &highlightMutable
	return r
}

func (r ApiUpdateHighlightConfigurationRequest) Execute() (*Highlight, *http.Response, error) {
	return r.ApiService.UpdateHighlightConfigurationExecute(r)
}

/*
UpdateHighlightConfiguration Update highlight configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiUpdateHighlightConfigurationRequest
*/
func (a *ReportsAPIService) UpdateHighlightConfiguration(ctx context.Context, orgId string, confId string) ApiUpdateHighlightConfigurationRequest {
	return ApiUpdateHighlightConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return Highlight
func (a *ReportsAPIService) UpdateHighlightConfigurationExecute(r ApiUpdateHighlightConfigurationRequest) (*Highlight, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *Highlight
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.UpdateHighlightConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.highlightMutable
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUpdateReportConfigurationRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
	reportConfigurationMutable *ReportConfigurationMutable
}

func (r ApiUpdateReportConfigurationRequest) ReportConfigurationMutable(reportConfigurationMutable ReportConfigurationMutable) ApiUpdateReportConfigurationRequest {
	r.reportConfigurationMutable = &reportConfigurationMutable
	return r
}

func (r ApiUpdateReportConfigurationRequest) Execute() (*ReportConfiguration, *http.Response, error) {
	return r.ApiService.UpdateReportConfigurationExecute(r)
}

/*
UpdateReportConfiguration Update report configuration

Update report configuration

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @return ApiUpdateReportConfigurationRequest
*/
func (a *ReportsAPIService) UpdateReportConfiguration(ctx context.Context, orgId string, confId string) ApiUpdateReportConfigurationRequest {
	return ApiUpdateReportConfigurationRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
	}
}

// Execute executes the request
//  @return ReportConfiguration
func (a *ReportsAPIService) UpdateReportConfigurationExecute(r ApiUpdateReportConfigurationRequest) (*ReportConfiguration, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ReportConfiguration
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.UpdateReportConfiguration")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.reportConfigurationMutable
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 422 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUpdateSubscriberRequest struct {
	ctx context.Context
	ApiService *ReportsAPIService
	orgId string
	confId string
	subscriberId string
	highlightSubscriberMutable *HighlightSubscriberMutable
}

func (r ApiUpdateSubscriberRequest) HighlightSubscriberMutable(highlightSubscriberMutable HighlightSubscriberMutable) ApiUpdateSubscriberRequest {
	r.highlightSubscriberMutable = &highlightSubscriberMutable
	return r
}

func (r ApiUpdateSubscriberRequest) Execute() (*HighlightSubscriber, *http.Response, error) {
	return r.ApiService.UpdateSubscriberExecute(r)
}

/*
UpdateSubscriber Update subscriber

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param orgId
 @param confId
 @param subscriberId
 @return ApiUpdateSubscriberRequest
*/
func (a *ReportsAPIService) UpdateSubscriber(ctx context.Context, orgId string, confId string, subscriberId string) ApiUpdateSubscriberRequest {
	return ApiUpdateSubscriberRequest{
		ApiService: a,
		ctx: ctx,
		orgId: orgId,
		confId: confId,
		subscriberId: subscriberId,
	}
}

// Execute executes the request
//  @return HighlightSubscriber
func (a *ReportsAPIService) UpdateSubscriberExecute(r ApiUpdateSubscriberRequest) (*HighlightSubscriber, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *HighlightSubscriber
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ReportsAPIService.UpdateSubscriber")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{org_id}/reports/configurations/{conf_id}/highlight/subscribers/{subscriber_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"org_id"+"}", url.PathEscape(parameterValueToString(r.orgId, "orgId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"conf_id"+"}", url.PathEscape(parameterValueToString(r.confId, "confId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"subscriber_id"+"}", url.PathEscape(parameterValueToString(r.subscriberId, "subscriberId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.highlightSubscriberMutable
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 422 {
			var v GenericResponse
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
